/* cleanctl.c
	cleaning control.
	by taka@exsys.prm.prug.or.jp */

#include <stdio.h>
#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>

#define	SPOOL	"/var/spool/news/control"
#define	LINELEN	256
#define	EXPTIME	(60*60*12)

char	*subjs[] =  {
	"ihave",
	"sendme",
	"alhave",
	"" };

main()
{
DIR	*df;
struct dirent	*dp;
char	buf[LINELEN];
char	buf1[LINELEN];
FILE	*fp;
int	hit;
struct stat	sb;
int	tim;
char	**ss;
	time(&tim);
	if ((df = opendir(SPOOL)) == NULL)
		exit(0);
	for (dp = readdir(df); dp != NULL; dp = readdir(df)) {
		if (dp->d_name[0] == '.')
			continue;
		sprintf(buf, "%s/%s", SPOOL, dp->d_name);
		if ((fp = fopen(buf, "r")) == NULL)
			continue;
		hit = 0;
		while (fgets(buf1, LINELEN,fp) != NULL) {
			if (strncmp(buf1, "Subject: ",9) == 0) {
				for(ss = subjs; **ss ; ++ss) {
					if (strstr(buf1+9, *ss) == 0) {
						hit = 1;
					}
				}
				break;
			}
		}
		fclose(fp);
		if (hit == 0)
			continue;
		if (stat(buf, &sb) != 0)
			continue;
		if (sb.st_mtime > (tim - EXPTIME)) {
/*
			printf("%d %d %d\n", tim, sb.st_mtime, tim-EXPTIME);
*/
			continue;
		}
/*
		printf("%s\n", buf);
*/
		unlink(buf);
	}
	closedir(df);
}

