/*	newsclean.c
 *
 *	1992 (C) taka@exsys.prm.prug.or.jp		Sat Jun 6 1992
 *
 *	newsclean : cleaning empty news spool dir
 *
 *	Usage : newsclean ng [ng....]
 */


#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include "defs.h"

main(argc,argv)
int	argc;
char	**argv;
{
int	i;
char	buf[256];

	if (argc == 1) {
		newsdir(NEWS_DIR);
	}
	else {
		for (i = 1; i < argc; i++) {
			newsdir(argv[i]);
		}
	}

	exit(0);
}


int newsdir(d)
char	*d;
{
DIR	*df;
struct dirent *dp;
int	flg;
char	buf[256];
struct stat sb;
	if ((df = opendir(d)) == NULL)
		return(0);
	flg = 0;
	for(dp = readdir(df); dp != NULL; dp = readdir(df)) {
		/* skip '.*' */
		if (dp->d_name[0] == '.')
			continue;
		/* skip *.* */
		if (strchr(dp->d_name,'.') != 0) {
			++flg;
			continue;
		}
		/* check DIRECTORY */
		sprintf(buf, "%s/%s", d, dp->d_name);
		if (stat(buf, &sb) != 0)
			continue;
		if (S_ISDIR(sb.st_mode)) {
			if (newsdir(buf))
				++flg;	/* not empty */
			continue;
		}
		/* file */
		++flg;
	}
	closedir(df);
	/* empty dir delete */
	if (flg == 0) {
		sprintf(buf, "rmdir '%s'", d);
		system(buf);
		printf("remove: %s\n", d);
	}
	return(flg);
}
		

