/* recvprog.c
	recv program
	(C)	taka@exsys.prm.prug.or.jp */

#include <stdio.h>
#include <pwd.h>
#include <string.h>

#define	STORDIR	"/home/taka/prog"
#define	LINELEN	512

char	*myprg;

main(argc,argv)
int	argc;
char	**argv;
{
char	tmp[LINELEN];
char	buf[LINELEN];
char	fname[LINELEN];
int	flag;
FILE	*fp;
char	subject[LINELEN];
	flag = 0;
	if ((myprg = strrchr(argv[0], '/')) == NULL)
		myprg = argv[0];
	else
		myprg++;
	/* cd STORDIR */
	umask(022);
	chdir(STORDIR);
	if (argc > 1)
		chdir(argv[1]);
	/* make tmp file */
	sprintf(tmp,"tmp%d", getpid());
	fp = fopen(tmp, "w");
	/* reading */
	while(fgets(buf,LINELEN,stdin) != NULL) {
		fputs(buf,fp);
		if (flag == 0) {
			/* check Subject */
			if (strncmp(buf,"Subject:", 8) == 0) {
				/* get fname */
				strcpy(subject, buf);
				getfname(buf,fname);
				++ flag;
			}
		}
	}
	/* make file name */
	if (flag) {
		fname[14] = 0;
		if (Access(fname,1) == 0) {
			make_file(fname);
		}
	}
	else {
		make_file(fname);
	}
	rename(tmp, fname);
	mailit(subject, fname);
	exit(0);
}

mailit(str,fname)
char *str;
{
int	id;
struct passwd *pass;
FILE	*fp;
char	buf[LINELEN];
	id = geteuid();
	pass = getpwuid(id);
	sprintf(buf, "mail %s", pass->pw_name);
	if ((fp = popen(buf, "w")) != NULL) {
		fprintf(fp,"%s executed.\n", myprg);
		fprintf(fp, "Stored file: %s\n",fname);
		fprintf(fp,"%s",str+8);
		pclose(fp);
	}
}

getfname(s, d)
char	*s;
char	*d;
{
int	flag;
	flag = 0;
	s += 8;
	/* skip space */
	while(*s) {
		switch(*s++) {
			case '\r' :
			case '\n' :
				break;
			case ' ' :
			case '\t' :
				if (flag == 0)
					continue;
				break;
			case '/' :
			case '\\' :
				if (flag == 0)
					continue;
				break;
			case '.' :
				if (flag == 0)
					continue;
			default :
				++flag;
				*d++ = *(s-1);
				continue;
		}
		break;
	}
	*d = 0;
}

make_file(fn)
char	*fn;
{
int	i;
	i = 0;
	sprintf(fn, "rcv%d", getpid());
	while( Access(fn,1) == 0) {
		++i;
		sprintf(fn, "rcv%d.%d",getpid(),i);
	}
}

Access(fn)
char	*fn;
{
FILE *fp;
	if ((fp = fopen(fn, "r")) == NULL)
		return(-1);
	fclose(fp);
	return(0);
}

