/*
 * rectera - receive articles from soroban. fot CNEWS
 *	by taka@exsys.prm.prug.or.jp (JF2CEX)
 */

#include <stdio.h>
#include <ctype.h>

#define BFSZ 2048	/* CEX931214 */

/* ARGSUSED */
main(argc, argv)
int argc;
char **argv;
{
	char buf[BFSZ];
	register FILE *pipe = NULL;

	while (fgets(buf, BFSZ, stdin) != NULL) {
		if (*buf == 'N') {
			if (pipe == NULL) {
				if ((pipe = popen(RNEWS, "w")) == NULL) {
					perror("rectera: popen failed");
					exit(1);
				}
			}
			fputs(buf+1, pipe);
		}
		else {
			if (pipe != NULL) {
				pclose(pipe);
				pipe = NULL;
			}
		}
	}
	if (pipe != NULL) {
		pclose(pipe);
	}
	exit(0);
}

