/*
 * sendtera - send news article by mail.
 */

#include <stdio.h>
#include <ctype.h>

#define	SENDMAIL	"/usr/lib/sendmail"
#define	BUFSIZE	2048

char buffer[BUFSIZE];

int linecount;

extern FILE *popen();

/* ARGSUSED */
main(argc, argv)
char **argv;
{
	register FILE *out;

	(void) sprintf(buffer, "%s -i %s", SENDMAIL, argv[1]);

	if ((out = popen(buffer, "w")) == NULL) {
		perror(buffer);
		exit(1);
	}

	/* Standard mail prelude to make the formatters happy */
	fprintf(out, "Subject: network news article\n");
	fprintf(out, "To: %s\n\n", argv[1]);

	while (fgets(buffer, sizeof buffer, stdin)) {
		if (strncmp(buffer, "#! rnews", 8) == 0) {
			putc('\n', out);
		}
		else {
			putc('N', out);
			fputs(buffer, out);
		}
		if (ferror(out))
			exit(1);
	}
	pclose(out);
	exit(0);
}

